import java.sql.*;
import java.io.*;
import oracle.jdbc.driver.*;

public class RefCursorExample2 {
  public static void main(String[] args) 
   throws SQLException, IOException {
  int ret_code;
  Connection conn = null;
  try {
      //Load and register Oracle driver
       DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
  //Establish a connection
	
    conn = DriverManager.getConnection("jdbc:oracle:thin:@training:1521:Oracle", "oratest", "oratest");

    String i_etype = "SENIOR";
    CallableStatement cstmt = conn.prepareCall("{? = call pkg_refcur.f_refcur(?)}");
    cstmt.registerOutParameter(1, OracleTypes.CURSOR);
    cstmt.setString(2, i_etype);
    cstmt.executeUpdate();

    ResultSet rset;
    rset = (ResultSet) cstmt.getObject(1);
    String str = "";
    while (rset.next())
      str += rset.getString(1)+" "+ rset.getInt(2)+" "+rset.getString(3)+" "+rset.getFloat(4)+" "+rset.getFloat(5)+" "+rset.getInt(6)+"\n";
    byte buf[] = str.getBytes();
    OutputStream fp = new FileOutputStream("senior.lst");
    fp.write(buf);
    fp.close();

    rset.close();
    cstmt.close();
    conn.close();
       } catch (SQLException e) {ret_code = e.getErrorCode(); System.err.println(ret_code + e.getMessage()); conn.close();}
         catch (IOException e) { System.err.println("Java File I/O Error:"+ e.getMessage()); }
   }
}
