import oracle.sql.*;
import java.sql.*;
import oracle.jdbc.driver.*;

public class RowidExample {
  public static void main(String[] args)
  throws SQLException {
int ret_code;
Connection conn = null;
  try {
      //Load and register Oracle driver
       DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
  //Establish a connection

    conn = DriverManager.getConnection("jdbc:oracle:thin:@training:1521:Oracle", "oratest", "oratest");
int i_deptno = 10;
   
   String sql1 = "SELECT ROWID, sal, comm FROM emp_1 WHERE deptno = ?" ;
   String sql2 = "UPDATE emp_1 SET sal = ? WHERE rowid = ?";

   PreparedStatement pstmt1 = conn.prepareStatement(sql1);
   PreparedStatement pstmt2 = conn.prepareStatement(sql2);

       pstmt1.setInt(1, i_deptno);
       ResultSet rset = pstmt1.executeQuery();
       while (rset.next()) {
         oracle.sql.ROWID i_rowid = ((OracleResultSet)rset).getROWID(1);
//         String i_rowid = "";
//         i_rowid = rset.getString(1);
         float i_sal =  rset.getFloat(2);
         float i_comm = rset.getFloat(3);
         pstmt2.setFloat(1, (float) (i_sal+(1.25*i_comm))); 
         ((OraclePreparedStatement)pstmt2).setROWID (2, i_rowid); 
//         pstmt2.setString(2, i_rowid);
         pstmt2.executeUpdate();
       }
   rset.close();
   pstmt1.close();
   pstmt2.close();
   conn.close();
       } catch (SQLException e) {ret_code = e.getErrorCode(); System.err.println(ret_code + e.getMessage()); conn.close();}
   }
}
