import java.sql.*;

public class StProcExample {
  public static void main(String[] args)
  throws SQLException {
int ret_code;
Connection conn = null;
  try {
      //Load and register Oracle driver
       DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
  //Establish a connection

    conn = DriverManager.getConnection("jdbc:oracle:thin:@training:1521:Oracle", "oratest", "oratest");
    int i_deptno = 10;
    CallableStatement pstmt = conn.prepareCall("{call p_highest_paid_emp(?,?,?,?)}");
    pstmt.setInt(1, i_deptno);
    pstmt.registerOutParameter(2, Types.INTEGER);
    pstmt.registerOutParameter(3, Types.VARCHAR);
    pstmt.registerOutParameter(4, Types.FLOAT);
    pstmt.executeUpdate();
    
    int o_empno = pstmt.getInt(2);
    String o_ename = pstmt.getString(3);
    float o_sal = pstmt.getFloat(4);
    System.out.print("The highest paid employee in dept "+i_deptno+" is: "+o_empno+" "+o_ename+" "+o_sal);
    pstmt.close();
    conn.close();
       } catch (SQLException e) {ret_code = e.getErrorCode(); System.err.println(ret_code + e.getMessage()); conn.close();}
   }
}
