import java.sql.*;

public class TransactionExample {
  public static void main(String[] args)
  throws SQLException {
int ret_code;
Connection conn = null;
  try {
      //Load and register Oracle driver
       DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
  //Establish a connection

    conn = DriverManager.getConnection("jdbc:oracle:thin:@training:1521:Oracle", "oratest", "oratest");

//Disable auto-commit mode
conn.setAutoCommit(false);
    
    String sql1 = "SELECT empno FROM emp WHERE empno = ?" ;
    String sql2 = "INSERT INTO emp VALUES (?,?,?,?,?,?,?,?)";
    String sql3 = "UPDATE dept_audit SET cnt_emp = nvl(cnt_emp,0) + 1 WHERE deptno = 10";

    PreparedStatement pstmt1 = conn.prepareStatement(sql1);
    PreparedStatement pstmt2 = conn.prepareStatement(sql2);
    PreparedStatement pstmt3 = conn.prepareStatement(sql3);

       pstmt1.setInt(1, 9999);
       ResultSet rset = pstmt1.executeQuery();
       if (rset.next()) {
         System.out.println("The employee with empno 9999 already exists.");
         rset.close();
         }
        else
         {
         pstmt2.setInt(1, 9999);
         pstmt2.setString(2, "CHARLIE");
         pstmt2.setString(3, "ANALYST");
         pstmt2.setInt(4, 7566);
         pstmt2.setString(5, "01-JAN-01");
         pstmt2.setFloat(6, 10000);
         pstmt2.setFloat(7, (float)10.5);
         pstmt2.setInt(8, 10);
         pstmt2.executeUpdate(); }
        
         pstmt3.executeUpdate();
         pstmt1.close();
         pstmt2.close(); 
         pstmt3.close();
         conn.commit();
         conn.close();
       } catch (SQLException e) {conn.rollback(); ret_code = e.getErrorCode(); System.err.println(ret_code + e.getMessage()); conn.close();}
   }
}
