import java.sql.*;
//import oracle.jdbc.driver.*;

public class AddressObj implements SQLData
{
  private String sql_type;
  public  int add_id;
  public  String line1;
  public  String line2;
  public  String city;
  public  String state;
  public  String zip;

  public AddressObj()
  {
  }
  public AddressObj(String i_sql_type, 
                    int    i_add_id,
                    String i_line1,
                    String i_line2,
                    String i_city,
                    String i_state,
                    String i_zip)
  {
   this.sql_type = i_sql_type;
   this.add_id = i_add_id;
   this.line1 = i_line1;
   this.line2 = i_line2;
   this.city = i_city;
   this.state = i_state;
   this.zip = i_zip;
  }
  
  public String getSQLTypeName() throws SQLException
  {
   return sql_type;
  }
  public void readSQL(SQLInput stream, String typeName)
     throws SQLException
  {
   sql_type = typeName;
   
   add_id = stream.readInt();
   line1 = stream.readString();
   line2 = stream.readString();
   city = stream.readString();
   state = stream.readString();
   zip = stream.readString();
  }
  public void writeSQL(SQLOutput stream)
    throws SQLException
  {
   stream.writeInt(add_id);
   stream.writeString(line1);
   stream.writeString(line2);
   stream.writeString(city);
   stream.writeString(state);
   stream.writeString(zip);
  }
  
}