import java.sql.*;
import oracle.sql.*;
import java.io.*;
import oracle.jdbc.driver.*;

public class BLOBExample2 {
  public static void main(String[] args)
  throws SQLException {
int ret_code;
Connection conn = null;
BufferedOutputStream outStream = null;
FileOutputStream fileStream = null;
int buffSize;
  try {
      //Load and register Oracle driver
       DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
  //Establish a connection

    conn = DriverManager.getConnection("jdbc:oracle:thin:@training:1521:Oracle", "oratest", "oratest");

    conn.setAutoCommit(false);

    Statement stmt = conn.createStatement();
    ResultSet rset = stmt.executeQuery("SELECT blob_data from lob_tab WHERE id = 1");

    if (rset.next()) {
      BLOB blob_data = ((OracleResultSet)rset).getBLOB(1);
      
      InputStream inStream = blob_data.getBinaryStream();
      buffSize = blob_data.getBufferSize();
      // Open the output file for writing
      fileStream = new FileOutputStream("out.bmp");
      outStream = new BufferedOutputStream(fileStream, buffSize);      

      byte[] nextChunk = new byte[buffSize];
      
     //read the first chunk of data from the BLOB
       
     int numOfBytes = inStream.read(nextChunk, 0, buffSize);

    // write the chunk read into the output file read nextChunk from the BLOB in a loop
     while (numOfBytes != -1) {
       outStream.write(nextChunk, 0, buffSize);
       numOfBytes = inStream.read(nextChunk, 0, buffSize);
      }
      outStream.close();
      inStream.close();     
    }    
    conn.close();
       } catch (SQLException e) {ret_code = e.getErrorCode(); System.err.println(ret_code + e.getMessage()); conn.close();}
         catch (Exception e) {System.out.println(e.getMessage());}
   }
}
