import oracle.sql.*;
import java.sql.*;
import java.math.*;
import oracle.jdbc.driver.*;

public class CollectionExample2 {
  public static void main(String[] args)
  throws SQLException {
int ret_code;
Connection conn = null;
  try {
      //Load and register Oracle driver
       DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
  //Establish a connection

    conn = DriverManager.getConnection("jdbc:oracle:thin:@training:1521:Oracle", "oratest", "oratest");

    Statement stmt = conn.createStatement();
    ResultSet rset = stmt.executeQuery("SELECT * FROM address_id_list");

    while (rset.next())
    {
      ARRAY address_id_array = ((OracleResultSet)rset).getARRAY(1);
      BigDecimal[] array_elements = (BigDecimal[]) address_id_array.getArray();
      int idx = 0;
      int len = array_elements.length;
      System.out.println("The array is as follows :");
      for (idx=0;idx<len;idx++)
      {
        BigDecimal array_element = (BigDecimal) array_elements[idx];
        System.out.println(array_element.intValue());
      }
    }
    stmt.close();
    conn.close();
       } catch (SQLException e) {ret_code = e.getErrorCode(); System.err.println(ret_code + e.getMessage()); conn.close();}
   }
}
