import java.sql.*;
import oracle.sql.*;
import java.math.*;
import oracle.jdbc.driver.*;

public class ObjectREFExample {
  public static void main(String[] args)
  throws SQLException, Exception {
int ret_code;
Connection conn = null;
  try {
      //Load and register Oracle driver
       DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
  //Establish a connection

    conn = DriverManager.getConnection("jdbc:oracle:thin:@training:1521:Oracle", "oratest", "oratest");

/*  Map map = (Map) conn.getTypeMap();
    map.put("SCOTT.ADDRESS", Class.forName("AddressObj"));
*/    
    Statement stmt = conn.createStatement();

    ResultSet rset = stmt.executeQuery("SELECT REF(a) FROM addresses a");
    System.out.println("The addresses are: ");
/*   AddressObj address1 = new AddressObj(); */
   STRUCT address1;
   while (rset.next()){
//     REF addr_ref = (REF) rset.getObject(1);
       REF addr_ref = ((OracleResultSet)rset).getREF(1);
     address1 = (STRUCT) addr_ref.getValue();
     Object addr_attrib[] = address1.getAttributes();
    System.out.println("Address Id = " +((BigDecimal)addr_attrib[0]).intValue()+" and the corresponding address is:");
    System.out.println(addr_attrib[1]);
    System.out.println(addr_attrib[2]);
    System.out.println(addr_attrib[3]+", "+addr_attrib[4]+" "+addr_attrib[5]);
}

   rset.close();
   stmt.close();
       } catch (SQLException e) {ret_code = e.getErrorCode(); System.err.println(ret_code + e.getMessage()); conn.close();}
         catch (Exception e) {System.err.println(e.getMessage()); conn.close();}
   }
}
