import java.sql.*;
import oracle.sql.*;
import oracle.jdbc.driver.*;

public class ObjectREFExample2 {
  public static void main(String[] args)
  throws SQLException, Exception {
int ret_code;
Connection conn = null;
  try {
      //Load and register Oracle driver
       DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
  //Establish a connection

    conn = DriverManager.getConnection("jdbc:oracle:thin:@training:1521:Oracle", "oratest", "oratest");

/*  Map map = (Map) conn.getTypeMap();
    map.put("SCOTT.ADDRESS", Class.forName("AddressObj"));
*/  
   String sql1 = "SELECT REF(a) FROM addresses a WHERE add_id = ?";
   String sql2 = "UPDATE emp_with_addr SET emp_addr = ? WHERE deptno = ?";  

   PreparedStatement pstmt1 = conn.prepareStatement(sql1);
   pstmt1.setInt(1, 1002);

    ResultSet rset = pstmt1.executeQuery();

    REF addr_ref = null;
/*   AddressObj address1 = new AddressObj(); */
   STRUCT address1;
   if (rset.next()){
//     REF addr_ref = (REF) rset.getObject(1);
       addr_ref = ((OracleResultSet)rset).getREF(1);
}
    PreparedStatement pstmt2 = conn.prepareStatement(sql2);
   ((OraclePreparedStatement)pstmt2).setREF(1, addr_ref);  
    pstmt2.setInt(2, 10);
    pstmt2.executeUpdate(); 
   rset.close();
   pstmt1.close();
   pstmt2.close();
       } catch (SQLException e) {ret_code = e.getErrorCode(); System.err.println(ret_code + e.getMessage()); conn.close();}
         catch (Exception e) {System.err.println(e.getMessage()); conn.close();}
   }
}
