package personp;

import javax.ejb.* ;
import java.rmi.RemoteException ;

public class PersonBean implements  SessionBean {

	private SessionContext mContext = null ;

	public void setSessionContext(SessionContext context)
	{
	    mContext = context ;
	    System.out.println("PersonBean context set") ;
	}

	public void ejbCreate()
	{
	    System.out.println("PersonBean Created") ;
	}

	public void ejbPassivate()
	{
	    System.out.println("PersonBean Passivated") ;
	}

	public void ejbActivate()
	{
	    System.out.println("PersonBean Activated") ;
	}

	public void ejbRemove()
	{
	    System.out.println("PersonBean Removed") ;
	}

	public String getName() throws RemoteException
	{
	   String str = new String("aName") ;
	   return str ;
	}

	public int getAge() throws RemoteException
	{
	  return 99 ;
	}
}
