package personp;

import javax.ejb.* ;
import javax.naming.* ;
import java.rmi.* ;
//import java.util.Properties ;
import java.util.Hashtable;
import oracle.aurora.jndi.sess_iiop.ServiceCtx;

public class PersonClient {

  public static void main(String[] args) {


	try {

        Hashtable env = new Hashtable();
        env.put(javax.naming.Context.URL_PKG_PREFIXES, "oracle.aurora.jndi");
        env.put(Context.SECURITY_PRINCIPAL, "oratest"); 
        env.put(Context.SECURITY_CREDENTIALS, "oratest"); 
        env.put(Context.SECURITY_AUTHENTICATION, ServiceCtx.NON_SSL_LOGIN); 
        Context ictx = new InitialContext(env);
        String serviceURL = "sess_iiop://training:2481:Oracle";
        String objectName = "/test/MyBean";
        PersonHome pHome = (PersonHome) ictx.lookup(serviceURL + objectName);


	Person person = pHome.create() ;

	String name = person.getName() ;
	int	 age  = person.getAge() ;

	System.out.println("Name from Bean: " + name) ;
	System.out.println("\nAge from Bean: " + age) ;

       }
       catch(Exception e)
	{
	   System.out.println("Error while creating/using person."+ e.getMessage()) ;
	}
     }
 }
