import java.sql.*;
import java.io.*;
import oracle.jdbc.driver.*;

public class DeptAudit {
  public static void DeptAuditRow(int i_deptno)
  throws SQLException {
    Connection conn = new OracleDriver().defaultConnection();
    String sql1 = "SELECT deptno FROM dept_audit WHERE deptno = ?" ;
    String sql2 = "INSERT INTO dept_audit VALUES (?,?)";
    String sql3 = "UPDATE dept_audit SET cnt_emp = nvl(cnt_emp,0) + 1 WHERE deptno = ?";
    int ret_code;
    int x = 1;
    try {
       PreparedStatement pstmt = conn.prepareStatement(sql1);
       pstmt.setInt(1, i_deptno);
       ResultSet rset = pstmt.executeQuery();
       if (rset.next()) {
         pstmt = conn.prepareStatement(sql3);
         pstmt.setInt(1, i_deptno);
         pstmt.executeUpdate();
         rset.close();
         pstmt.close();
         }
        else
         {
         pstmt = conn.prepareStatement(sql2);
         pstmt.setInt(1, i_deptno);
         pstmt.setInt(2, x);
         pstmt.executeUpdate();
         rset.close();
         pstmt.close(); }
       } catch (SQLException e) {ret_code = e.getErrorCode(); System.err.println(ret_code + e.getMessage());}
   }
}
   
