import java.sql.*;

public class UpdateableResultSetExample {
  public static void main(String[] args)
  throws SQLException {
int ret_code;
Connection conn = null;
  try {
      //Load and register Oracle driver
       DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
  //Establish a connection

    conn = DriverManager.getConnection("jdbc:oracle:thin:@training:1521:Oracle", "oratest", "oratest");
   int i_deptno = 10;
   String sql = "SELECT empno, sal, comm FROM emp_with_type WHERE deptno = ?" ;
   PreparedStatement pstmt = conn.prepareStatement(sql, ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE);
       pstmt.setInt(1, i_deptno);
       ResultSet rset = pstmt.executeQuery();
       while (rset.next()) {
         float i_sal = rset.getFloat(2);
         float i_comm = rset.getFloat(3);
         rset.updateFloat(2, (float)(i_sal+(1.25*i_comm)));
         rset.updateRow();
         }

   rset.close();
   pstmt.close();
   pstmt.close();
   conn.close();
       } catch (SQLException e) {ret_code = e.getErrorCode(); System.err.println(ret_code + e.getMessage()); conn.close();}
   }
}
