import oracle.sql.*;
import java.sql.*;
import java.math.*;
import oracle.jdbc.driver.*;

public class CollectionExample {
  public static void main(String[] args)
  throws SQLException {
int ret_code;
Connection conn = null;
  try {
      //Load and register Oracle driver
       DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
  //Establish a connection

    conn = DriverManager.getConnection("jdbc:oracle:thin:@training:1521:Oracle", "oratest", "oratest");

   ArrayDescriptor address_id_ad = ArrayDescriptor.createDescriptor("ADDRESS_ID_VARRAY", conn);    

   Statement stmt = conn.createStatement();
   ResultSet rset = stmt.executeQuery("SELECT COUNT(add_id) from addresses");
   rset.next();
   int num_rows = rset.getInt(1);
   rset.close();
   rset = stmt.executeQuery("SElECT add_id from addresses");

   int  address_id_list[] = new int[num_rows];
   int i=0, val;
   while (rset.next())
   {
    val = rset.getInt(1);
    address_id_list[i] = val;
    i++;
   }
   rset.close();
   stmt.close();
   ARRAY address_id_array = new ARRAY(address_id_ad, conn, address_id_list);

   PreparedStatement pstmt = conn.prepareStatement("INSERT INTO address_id_list VALUES (?)");
   ((OraclePreparedStatement)pstmt).setARRAY(1, address_id_array);

   pstmt.executeUpdate();
   pstmt.close();
   conn.close();
       } catch (SQLException e) {ret_code = e.getErrorCode(); System.err.println(ret_code + e.getMessage()); conn.close();}
   }
}
