import oracle.sql.*;
import java.sql.*;
import java.math.*;

public class ObjectTypeExample {
  public static void main(String[] args)
  throws SQLException {
int ret_code;
Connection conn = null;
  try {
      //Load and register Oracle driver
       DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
  //Establish a connection

    conn = DriverManager.getConnection("jdbc:oracle:thin:@training:1521:Oracle", "oratest", "oratest");

    StructDescriptor address_sd = StructDescriptor.createDescriptor("ADDRESS", conn);
    Object[] address_attrib;
    address_attrib = new Object [6];
    address_attrib[0] = new BigDecimal(1001);
    address_attrib[1] = "50 RockFeller Plaza";
    address_attrib[2] = "";
    address_attrib[3] = "New York";
    address_attrib[4] = "NY";
    address_attrib[5] = "10020";

    STRUCT address_struct = new STRUCT(address_sd, conn, address_attrib);
   
    String sql = "INSERT INTO addresses values (?)" ;
  
    PreparedStatement pstmt = conn.prepareStatement(sql);
    pstmt.setObject(1, address_struct);
    pstmt.executeUpdate();
   pstmt.close();
   conn.close();
       } catch (SQLException e) {ret_code = e.getErrorCode(); System.err.println(ret_code + e.getMessage()); conn.close();}
   }
}
