import oracle.sql.*;
import java.sql.*;
import java.math.*;

public class ObjectTypeExample2 {
  public static void main(String[] args)
  throws SQLException {
int ret_code;
Connection conn = null;
  try {
      //Load and register Oracle driver
       DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
  //Establish a connection

    conn = DriverManager.getConnection("jdbc:oracle:thin:@training:1521:Oracle", "oratest", "oratest");
  
    Statement stmt = conn.createStatement();
    ResultSet rset = stmt.executeQuery("SELECT VALUE(a) FROM addresses a");
    System.out.println("The addresses are as follows:\n");
    while (rset.next())
    {
     STRUCT address_struct = (STRUCT) rset.getObject(1);
     Object [] address_attrib = address_struct.getAttributes();
     System.out.println(((BigDecimal)address_attrib[0]).intValue());
     System.out.println((String) address_attrib[1]);
     System.out.println((String) address_attrib[2]);
     System.out.println((String)address_attrib[3]+", "+(String)address_attrib[4]+" "+(String)address_attrib[5]);
    }
   stmt.close();
   conn.close();
       } catch (SQLException e) {ret_code = e.getErrorCode(); System.err.println(ret_code + e.getMessage()); conn.close();}
   }
}
