import oracle.sql.*;
import java.sql.*;
import java.math.*;
import java.util.Map;

public class ObjectTypeExample3 {
  public static void main(String[] args)
  throws SQLException, Exception {
int ret_code;
Connection conn = null;
  try {
      //Load and register Oracle driver
       DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
  //Establish a connection

    conn = DriverManager.getConnection("jdbc:oracle:thin:@training:1521:Oracle", "oratest", "oratest");

    Map map = (Map) conn.getTypeMap();
    map.put("ADDRESS", Class.forName("AddressObj"));

   AddressObj address1 = new AddressObj("SCOTT.ADDRESS", 1002, "27 Thornall St.", "","Chicago", "IL", "23456");

   PreparedStatement pstmt = conn.prepareStatement("insert into addresses values (?)");
   pstmt.setObject(1, address1);
   pstmt.executeUpdate();
   pstmt.close();
       } catch (SQLException e) {ret_code = e.getErrorCode(); System.err.println(ret_code + e.getMessage()); conn.close();}
         catch (Exception e) {System.err.println(e.getMessage()); conn.close();}
   }
}
