import java.sql.*;
import java.util.Map;

public class ObjectTypeExample4 {
  public static void main(String[] args)
  throws SQLException, Exception {
int ret_code;
Connection conn = null;
  try {
      //Load and register Oracle driver
       DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
  //Establish a connection

    conn = DriverManager.getConnection("jdbc:oracle:thin:@training:1521:Oracle", "oratest", "oratest");


    Map map = (Map) conn.getTypeMap();
    map.put("SCOTT.ADDRESS", Class.forName("AddressObj"));
    
    Statement stmt = conn.createStatement();

    ResultSet rset = stmt.executeQuery("SELECT VALUE(a) FROM addresses a");
    System.out.println("The addresses are: ");
   AddressObj address1 = new AddressObj();
   while (rset.next()) {
    address1 = (AddressObj) rset.getObject(1);
    System.out.println("Address Id = " +address1.add_id+" and the corresponding address is:");
    System.out.println(address1.line1);
    System.out.println(address1.line2);
    System.out.println(address1.city+", "+address1.state+" "+address1.zip);
   }
   rset.close();
   stmt.close();
       } catch (SQLException e) {ret_code = e.getErrorCode(); System.err.println(ret_code + e.getMessage()); conn.close();}
         catch (Exception e) {System.err.println(e.getMessage()); conn.close();}
   }
}
