import java.io.*;
import java.sql.*;
public class DeptBean implements Serializable {
  private int dbDeptNo;
  private String dbDname;
  private String dbLoc;

  private Connection Conn = null;

  // default constructor
  public DeptBean()
  {
   try {
          DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
          Conn = DriverManager.getConnection
                ("jdbc:oracle:thin:@ASSOCIAT-SZECHG:1521:Oracle",
                  "scott", "tiger");
          Conn.setAutoCommit(false);
      }
      catch (SQLException e) {Conn = null; }
  }

  protected void finalize()
  {
    try {
           Conn.close();
    } catch (SQLException e) { }
  } 

  public int getdbDeptNo()
  {
    return this.dbDeptNo;
  }
  public void setdbDeptNo(int valDeptNo)
  {
    this.dbDeptNo = valDeptNo;
  }
  public String getdbDname()
  {
    return this.dbDname;
  }
  public void setdbDname(String valDname)
  {
    this.dbDname = valDname;
  }
  public String getdbLoc()
  {
    return this.dbLoc;
  }
  public void setdbLoc(String valLoc)
  {
    this.dbLoc = valLoc;
  }
  public int InsertDept()
    throws SQLException  {
    int ret_val = 0;
    int numRows = 0;
    try {
       if (Conn == null) 
         {ret_val = -1;}
       else
       {
         String sql = "INSERT INTO dept VALUES (?,?,?)";
         PreparedStatement pstmt = Conn.prepareStatement(sql);
         pstmt.setInt(1, this.dbDeptNo);
         pstmt.setString(2, this.dbDname);
         pstmt.setString(3, this.dbLoc);
         numRows = pstmt.executeUpdate();
         Conn.commit();
       }
    return (ret_val);   
    } catch(SQLException e){ ret_val = -1; Conn.rollback();return (ret_val);}
  }

  public int UpdateDept()
      throws SQLException {
    int ret_val = 0;
    int numRows = 0;
    try {
          if (Conn == null) 
            {ret_val = -1;}
          else
          {
             String sql = "UPDATE dept SET dname =?, loc = ? WHERE deptno = ?";
             PreparedStatement pstmt = Conn.prepareStatement(sql);
             pstmt.setString(1, this.dbDname);
             pstmt.setString(2, this.dbLoc);
             pstmt.setInt(3, this.dbDeptNo);
             numRows = pstmt.executeUpdate();
             Conn.commit();
          }
         return (ret_val);
    } catch(SQLException e){ ret_val = -1; Conn.rollback();return (ret_val);}
  }

  public int DeleteDept()
      throws SQLException {
    int ret_val = 0;
    int numRows = 0;
    try {
          if (Conn == null) 
            {ret_val = -1;}
          else
          {
            String sql = "DELETE dept WHERE deptno = ?";
            PreparedStatement pstmt = Conn.prepareStatement(sql);
            pstmt.setInt(1, this.dbDeptNo);
            numRows = pstmt.executeUpdate();
            Conn.commit();
         }
         return (ret_val);
    } catch(SQLException e){ ret_val = -1; Conn.rollback();return (ret_val);}
  }

}
