import java.beans.*;
public class GeneralizedBeanInfo {
  public static void main(String[] args) {
    try {
      BeanInfo bi = Introspector.getBeanInfo(DeptBean.class);
      BeanDescriptor bd = bi.getBeanDescriptor();
      String beanName = bd.getName();
      System.out.println("The Bean Name is " + beanName);
      System.out.println("The properties of the bean are: ");
      PropertyDescriptor pd[] = bi.getPropertyDescriptors();
      int plen = pd.length;
      for (int i = 0;i < plen;i++)
      {
        String pname = pd[i].getName();
        System.out.println("\t" + pname);
      }
      System.out.println("The Methods of the bean are: ");
      MethodDescriptor md[] = bi.getMethodDescriptors();
      int mlen = md.length;
      for (int i = 0;i < mlen;i++)
      {
        String mname = md[i].getName();
        System.out.println("\t" + mname);
      }
      System.out.println("The events of the bean are: ");
      EventSetDescriptor ed[] = bi.getEventSetDescriptors();
      int elen = ed.length;
      for (int i = 0;i < elen;i++)
      {
        String ename = ed[i].getName();
        System.out.println("\t" + ename);
      }
    } catch (Exception e) { System.out.println("Error: " + e); }
  }
}
